{{
##################################
# jvmVpDemo - Demo for jvmVpCore #
##################################

This is the demo section only. See jvmVpCore.spin for detailed design.

}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ
  vp : "jvmVpCore"
  jd : "jvmVpData"
  def: "jvmDefines"
  sio: "jvmSerial"

VAR
  long vpRambank
  
PUB main

  sio.start(31,30,0,9600)
  sio.rx ' comment to not pause before demo
  vpRambank := vp.getVpRamAddr

  sio.tx($d)
  sio.str(string("vpRamBank address: "))
  sio.hex(vpRambank,4)

  vp.startVP(def#nmPeriph0Bank, vp#VP_TIMER)
  vp.startVP(def#nmPeriph1Bank, vp#VP_TIMER)
  vp.startVP(def#nmPeriph2Bank, vp#VP_TIMER)
  vp.startVP(def#nmPeriph3Bank, vp#VP_TIMER)
  vp.startVP(def#nmPeriph4Bank, vp#VP_TIMER)
  vp.startVP(def#nmPeriph5Bank, vp#VP_TIMER)
  
  'doTimer(def#nmPeriph0Bank)
  'doPWM(def#nmPeriph5Bank, 2, 6, 3)

  repeat
    printTimer(def#nmPeriph0Bank)
    vp.pause(200)
  
PUB doPWM(bank, pin, hi, lo)
  vp.startPWM(bank, 0, pin, hi, lo)


PUB doTimer(bank)
  vp.startVP(bank, vp#VP_TIMER)
  printTimer(bank)
  vp.pause(1000)
  printTimer(bank)

  vp.stopVP(bank)
  printTimer(bank)

  vp.startVP(bank, vp#VP_TIMER)
  vp.writeReg(bank + def#nmTimer1, 0)

  repeat
    vp.pause(200)
    printTimer(bank)
    'dumpBytes(jd.getVpRamAddr,$10)


PRI printTimer(bank) | value
  sio.str(string($d,"printTimer bank "))
  sio.hex(bank,4)
{  
  value := vp.readReg(bank + def#nmTimer1)
  sio.tx(" ")
  sio.hex(value,8)
  vp.writeReg(bank + def#nmLatchTimer1, value)

  value := vp.readReg(bank + def#nmLatchTimer1)
  sio.tx(" ")
  sio.hex(value,8)
}
  
  vp.writeReg(bank + def#nmLatchTimer1,vp.readReg(bank + def#nmTimer1))
'  vp.writeReg(bank + def#nmLatchTimer2,vp.readReg(bank + def#nmTimer2))
'  vp.writeReg(bank + def#nmLatchTimer3,vp.readReg(bank + def#nmTimer3))
'  vp.writeReg(bank + def#nmLatchTimer4,vp.readReg(bank + def#nmTimer4))

  'dumpBank(bank)

  'vp.latchVPtimer(bank)
  
  sio.str(string(" raw: "))
  sio.hex(def#nmTimer1,4)
  sio.tx(" ")

  sio.hex(vp.readReg(bank + def#nmTimer1),8)

  sio.str(string(" latched: "))
  sio.hex(def#nmLatchTimer1,4)
  sio.tx(" ")

  sio.hex(vp.readReg(bank + def#nmLatchTimer1),8)

PRI dumpBank(bank) | ii, buff[$80]
  repeat ii from 0 to $10
    buff[ii] := vp.readReg(bank+ii)
    'sio.tx(" ")
    'sio.hex(buff[ii],8)
  dumpBytes(@buff, $40)
  sio.tx($d)
  
PRI dumpBytes(addr,len) | ndx, bytes[17], bi, sz
{{
/**
 * dump bytes in 8 column table
 * @param addr is base address for dump
 * @param len is number of bytes to dump
 */
__ void dumpBytes(addr,len);
}}
  ndx := 0
  sz  := 16
  'str(string("Dump"))
  repeat while(ndx < len)
    if ndx <> 0 and (ndx // sz) <> 0
      sio.tx(".")
      bytes[bi++ // sz] := byte[addr+ndx-1] 
    if ndx == 0 or (ndx // sz) == 0
      if ndx <> 0
        bytes[bi] := byte[addr+ndx-1]
        sio.tx(" ")
        repeat bi from 0 to sz-1
          if (bytes[bi] => $20)
            sio.tx(bytes[bi])
          else
            sio.tx(".")
      sio.tx($d)
      sio.hex(addr+ndx,4)
      sio.tx(":")
      sio.tx(" ")
      bi  := 0
    sio.hex(byte[addr+ndx],2)
    ndx++
    
  if ndx <> 0
     sio.tx(" ")
     bytes[bi] := byte[addr+ndx-1]
     repeat bi from 0 to sz-1
       if (bytes[bi] => $20)
         sio.tx(bytes[bi])
       else
         sio.tx(".")